# Formulator - Let's you manage Forms on the ZOPE Application Server
# Copyright (C) 2001 Christian Theune, gocept gmbh & co. kg
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
#
# Module for Fileupload
#
# $Id: HTMLFileupload.py,v 1.5 2001/06/11 22:15:23 ctheune Exp $

__doc__="""HTMLWidget Fileupload module."""
__version__='0.1'

from Globals import HTMLFile
from Globals import MessageDialog
from Globals import Persistent

import OFS.SimpleItem
from OFS.DTMLDocument import DTMLDocument
import Acquisition
import AccessControl

import re

True=1
False=0

manage_addHTMLFileuploadForm=HTMLFile('dtml/HTMLFileuploadAdd', globals())

def manage_addHTMLFileupload(self, id, REQUEST=None):
    """ This will instanciate a new Fileupload Widget in the ZODB"""
    self._setObject(id, HTMLFileupload(id, REQUEST))
    if REQUEST is not None:
        return self.manage_main(self, REQUEST)

class HTMLFileupload(OFS.SimpleItem.Item, Persistent, Acquisition.Implicit, \
                AccessControl.Role.RoleManager ):
    """HTMLWidget for Fileuploads"""

    meta_type='HTML Fileupload'
    css_class='fileupload'
    
    colspan=0
    required=0
        
    manage_properties=HTMLFile('dtml/HTMLFileuploadEdit', globals())
    
    manage_options=(
        {'label':'Properties', 'action':'manage_properties', 'target':None},
        {'label':'Security', 'action':'manage_access', 'target':None},
	)

    def __init__(self, id, REQUEST):
        self.id=id
	if REQUEST is not None:
	    self.changeProperties(REQUEST)

    def index_html(self, REQUEST=None):
        htmltext='<input type="file" name="%s">' % (self.id)
        return htmltext

    def manage_edit(self, REQUEST=None):
        """ set the new properties """
	if REQUEST is not None:
	    self.changeProperties(REQUEST)
            return MessageDialog(title='Edited',
                message="Properties for %s changed." % self.id,
                action='./manage_properties' )
	    	
    def __str__(self):
        return self.index_html(self)

    def __call__(self):
        return self.index_html(self)

    def __validate__(self, against=None):
	if (self.required) and not hasattr(against,'filename'):
	    return False
	return True
	
    def height(self):
        return 1

    def value(self, REQUEST=None):
	return None
    
    def changeProperties(self, REQUEST=None):
        if REQUEST is not None:
            self.title=REQUEST.title
            self.hint=REQUEST.hint
            self.column=REQUEST.column
            self.row=REQUEST.row
	    self.colspan=REQUEST.colspan
	    	    
	    self.required=0
	    if REQUEST.has_key('required'):
		self.required=1
	
    
# $Log: HTMLFileupload.py,v $
# Revision 1.5  2001/06/11 22:15:23  ctheune
# added new changeProperties behaviour for editing Items
# cleaned up
# added support for new spanning Method
# fixed bug when checking if upload was required in __validate__
# removed debugging code
#
# Revision 1.4  2001/06/07 16:26:27  ctheune
# fixed bug 118
#
# Revision 1.3  2001/06/07 16:12:43  ctheune
# fixed bug 117
#
# Revision 1.2  2001/06/07 13:02:55  ctheune
# fixed some syntax errors
# fixed support for HTMLFileupload
# added enctype
#
# Revision 1.1  2001/06/07 11:10:04  ctheune
# imported sources
#
