# Formulator - Let's you manage Forms on the ZOPE Application Server
# Copyright (C) 2001 Christian Theune, gocept gmbh & co. kg
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
#
# Module for Label-Widgets
#
# $Id: HTMLLabel.py,v 1.4 2001/06/11 22:16:11 ctheune Exp $

__doc__ = """HTMLLabel Button module."""
__version__ = '0.1'

from Globals import HTMLFile
from Globals import MessageDialog
from Globals import Persistent

import OFS.SimpleItem
from OFS.DTMLDocument import DTMLDocument
import Acquisition
import AccessControl

True=1
False=0

manage_addHTMLLabelForm=HTMLFile('dtml/HTMLLabelAdd', globals())

def manage_addHTMLLabel(self, id, REQUEST=None):
    """Adds a new HTML Label to the Folder."""
    self._setObject(id, HTMLLabel(id, REQUEST))
    if REQUEST is not None:
        return self.manage_main(self, REQUEST)

class HTMLLabel(OFS.SimpleItem.Item, Persistent, Acquisition.Implicit,
                AccessControl.Role.RoleManager):
    """HTMLWidget for Labels"""

    meta_type='HTML Label'
    css_class=None
    colspan=-1
    
    manage_properties=HTMLFile('dtml/HTMLLabelEdit', globals())
 
    manage_options=(
        {'label':'Properties', 'action':'manage_properties', 'target':None},
        {'label':'Security', 'action':'manage_access', 'target':None},
        )

    def __init__(self, id, REQUEST=None):
        self.id=id
	if REQUEST is not None:
	    self.changeProperties(REQUEST)
	    
    def index_html(self, REQUEST=None):
	return self.value

    def manage_edit(self, REQUEST=None):
        """ set the new properties """
	if REQUEST is not None:
	    self.changeProperties(REQUEST)
            return MessageDialog(title='Edited',
                message="Properties for %s changed." % self.id,
                action='./manage_properties')

    def changeProperties(self, REQUEST=None):
        if REQUEST is not None:
            self.value=REQUEST.value
            self.column=REQUEST.column
            self.row=REQUEST.row
	    self.colspan=REQUEST.colspan
    
    def __str__(self):
        return self.index_html(self)

    def __validate__(self, against=None):
        return True

    def height(self):
        return 1
    

# $Log: HTMLLabel.py,v $
# Revision 1.4  2001/06/11 22:16:11  ctheune
# added new changeProperties behaviour for editing Items
# cleaned up
# added support for new spanning Method
# fixed bug when checking if upload was required in __validate__
#
# Revision 1.3  2001/06/07 16:26:27  ctheune
# fixed bug 118
#
# Revision 1.2  2001/04/10 20:00:59  ctheune
# fixed __init__ parameters
#
# Revision 1.1  2001/04/10 09:21:58  ctheune
#  added HTML Label widget
#
