# Formulator - Let's you manage Forms on the ZOPE Application Server
# Copyright (C) 2001 Christian Theune, gocept gmbh & co. kg
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
#
# Initialize the HTMLForm Product
#
# $Id: __init__.py,v 1.6 2001/06/11 22:20:11 ctheune Exp $

import HTMLForm
import HTMLButton
import HTMLLabel
import HTMLTextfield
import HTMLTextarea
import HTMLMenu
import HTMLFileupload

def initialize(context):
    try:
        context.registerClass(
            HTMLForm.HTMLForm,
            constructors = (
                HTMLForm.manage_addHTMLFormForm,
                HTMLForm.manage_addHTMLForm)
             , icon = 'www/HTMLForm.gif'
            )

        context.registerClass(
            HTMLButton.HTMLButton,
            constructors = (
                HTMLButton.manage_addHTMLButtonForm,
                HTMLButton.manage_addHTMLButton)
             , icon = 'www/HTMLButton.gif'
            )

        context.registerClass(
            HTMLLabel.HTMLLabel,
            constructors = (
                HTMLLabel.manage_addHTMLLabelForm,
                HTMLLabel.manage_addHTMLLabel)
             #, icon = 'www/HTMLButton.gif'
            )

        context.registerClass(
            HTMLTextfield.HTMLTextfield,
            constructors = (
                HTMLTextfield.manage_addHTMLTextfieldForm,
                HTMLTextfield.manage_addHTMLTextfield)
             , icon = 'www/HTMLTextfield.gif'
            )

        context.registerClass(
            HTMLTextarea.HTMLTextarea,
            constructors = (
                HTMLTextarea.manage_addHTMLTextareaForm,
                HTMLTextarea.manage_addHTMLTextarea)
             #, icon = 'www/HTMLTextarea.gif'
            )

        context.registerClass(
            HTMLMenu.HTMLMenu,
            constructors = (
                HTMLMenu.manage_addHTMLMenuForm,
                HTMLMenu.manage_addHTMLMenu)
             #, icon = 'www/HTMLMenu.gif'
            )

        context.registerClass(
            HTMLFileupload.HTMLFileupload,
            constructors = (
                HTMLFileupload.manage_addHTMLFileuploadForm,
                HTMLFileupload.manage_addHTMLFileupload,
             #, icon = 'www/HTMLMenu.gif'
            )
	)

	context.registerHelp()
	context.registerHelpTitle("Zope Help")
		        
    except:
        import sys, traceback, string
        type, val, tb = sys.exc_info()
        sys.stderr.write(string.join(traceback.format_exception(type, val, \
								 tb), ''))
        del type, val, tb

# $Log: __init__.py,v $
# Revision 1.6  2001/06/11 22:20:11  ctheune
# cleaned up
#
# Revision 1.5  2001/06/07 13:02:55  ctheune
# fixed some syntax errors
# fixed support for HTMLFileupload
# added enctype
#
# Revision 1.4  2001/06/07 11:17:37  ctheune
# added support for file upload classapplication/HTMLForm/HTMLForm.py
#
# Revision 1.3  2001/04/10 20:05:02  ctheune
# modified for usage with HTML Label
#
# Revision 1.2  2001/04/03 17:45:09  ctheune
# changed cvs tag Revision to ID as described in Bug #10 on bugzilla.gocept.com
#
# Revision 1.1  2001/03/30 12:48:43  ctheune
# added __init__ module
#
